<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: AdvertisementZoneImpressionAllocation.php 2024 2005-03-10 17:21:43Z andrew $
*/

/**
 * @package    MaxMaintenance
 * @subpackage Priority
 * @author     Andrew Hill <andrew@awarez.net>
 */

/**
 * A factory class for creating
 * {@link Maintenance_Priority_AdServer_AdvertisementZoneImpressionAllocation_Common}
 * subclass objects.
 */
class Maintenance_Priority_AdServer_AdvertisementZoneImpressionAllocation
{
    /**
     * The factory method used to instantiate a class that implements the
     * {@link Maintenance_Priority_AdServer_AdvertisementZoneImpressionAllocation_Common}
     * interface.
     *
     * @static
     *
     * @param string $name The name of the subclass to instantiate.
     * @return {@link Maintenance_Priority_AdServer_AdvertisementZoneImpressionAllocation_Common}
     *         The class object created.
     */
    function instance($name = 'Normal')
    {
        $conf = $GLOBALS['_MAX']['CONF'];
        $classname = 'Maintenance_Priority_AdServer_AdvertisementZoneImpressionAllocation_' . $name;
        $includeFile = MAX_PATH . '/lib/max/Maintenance/Priority/AdServer/' . 
                       'AdvertisementZoneImpressionAllocation/' . $name . '.php';
        @include_once $includeFile;
        if (!class_exists($classname)) {
            // Unable to include the specified class file - raise error and halt
            MAX::debug('Unable to find the "' . $classname . '" class in the "' . $includeFile .
                       '" file.', PEAR_LOG_ERR);
            MAX::debug('Aborting script execution', PEAR_LOG_ERR);
            exit();
        }
        // Instantiate the class
        return new $$classname();
    }
}

?>
