<?php
/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.2                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: GeoIP.php 1917 2005-03-03 15:27:28Z radek $
*/

/**
 * @package    MaxPlugins
 * @author     Radek Maciaszek <radek@awarez.net>
 */

require_once MAX_PATH . '/lib/max/Plugins/Plugins.php';

/**
 *
 * Max_CommonPlugin is an common class for every plugin
 *
 */
class Max_CommonPlugin
{
    var $module;
    var $package;
    var $name;
    
    /**
     * Method for reading the specific plugin config file
     *
     * @param boolean $processSections        If true the configuration data is returned
     *                                        as one dimension array
     * @param boolean $commonPackageConfig    If true read the global plugin.conf.ini file
     *                                        for specific package
     *
     * @return object                         Plugin object or false if any error occured
     *
     */
    function getConfig($processSections = false, $commonPackageConfig = true)
    {
        return Max_Plugins::staticGetConfig($this->module, $this->package, $this->name, $commonPackageConfig, $processSections);
    }
    
    /**
     * Method return the string containing package or plugin config name
     *
     * @param boolean $commonPackageConfig    If true read the global plugin.conf.ini file
     *                                        for specific package
     *
     * @return object                         Plugin object or false if any error occured
     *
     */
    function getConfigFileName($commonPackageConfig = true)
    {
        return Max_Plugins::getConfigFileName($this->module, $this->package, $this->name, $commonPackageConfig);
    }
    
    /**
     * Method return module config file name
     *
     * @return object    Plugin object or false if any error occured
     *
     */
    function getModuleConfigFileName()
    {
        return MAX_PATH . '/plugins/'.$this->module.'/plugin.conf.ini';
    }
}

?>