<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: TestOfDalTableStatisticsMySql.php 1610 2005-02-21 15:18:29Z andrew $
*/

/**
 * @package    MaxDal
 * @subpackage TestSuite
 * @author     Andrew Hill <andrew@awarez.net>
 */

require_once MAX_PATH . '/lib/Max.php';
require_once MAX_PATH . '/lib/max/DB.php';
require_once MAX_PATH . '/lib/max/Table/Statistics.php';

/**
 * A class for testing the MAX_Table_Statistics class.
 */
class MAX_TestOfMaxTableStatistics extends UnitTestCase
{
    
    /**
     * The constructor method.
     */
    function MAX_TestOfMaxTableStatistics()
    {        
        $this->UnitTestCase();
    }
    
    /**
     * Tests that the singleton() method only ever returns one
     * class instance.
     */
    function testSingleton()
    {
        MAX::debug('Running test', PEAR_LOG_INFO);
        $first = MAX_Table_Statistics::singleton('mysql');
        $second = MAX_Table_Statistics::singleton('mysql');
        $this->assertIdentical($first, $second);
    }
    
    /**
     * Tests creating/dropping all of the maintenance statistics tables.
     */
    function testAllMaintenanceStatisticsTables()
    {
        MAX::debug('Running test', PEAR_LOG_INFO);
        $dbh =& MAX_DB::singleton();
        // Tables to test
        $tmpTables = array(
            'tmp_ad_impression',
            'tmp_ad_click',
            'tmp_tracker_impression_ad_impression_connection',
            'tmp_tracker_impression_ad_click_connection',
            'tmp_ad_connection'
        );
        $tempTables = MAX_Table_Statistics::singleton('mysql');
        foreach ($tmpTables as $tbl) {        
            $tempTables->createTable($tbl);
            $query = "SELECT COUNT(*) AS number FROM $tbl";
            $row = $dbh->getRow($query);
            if (PEAR::isError($row)) {
                return MAX::raiseError($row, MAX_ERROR_DBFAILURE);
            }
            $this->assertEqual($row['number'], 0);
            $tempTables->dropTempTable($tbl);
        }
    }
    
}

?>
