<?php
/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: all_tests.php 2225 2005-03-18 15:21:23Z andrew $
*/

/**
 * @package    Max
 * @subpackage TestSuite
 * @author     Andrew Hill <andrew@awarez.net>
 */

/**
 * A script for running all tests in the project.
 */

// Require the initialisation file
require_once '../init.php';

// Require that the configuration use a max_ table prefix
$conf =& $GLOBALS['_MAX']['CONF'];
$conf['table']['prefix'] = 'max_';

// Include the simpletest classes, if required
require_once MAX_PATH . '/lib/simpletest/unit_tester.php';
require_once MAX_PATH . '/lib/simpletest/reporter.php';

// Output the HTML header
include_once MAX_PATH . '/tests/header.html';

// Record the test start time
$testStart = time();

// Run the Table Library tests
require_once MAX_PATH . '/lib/max/Table/tests/all_tests.php';

// Run the Data Access Layer (Maintenance) tests
require_once MAX_PATH . '/lib/max/Dal/tests/all_tests.php';

// Run the Data Access Layer (User Interface) tests
require_once MAX_PATH . '/lib/max/tests/all_tests.php';

// Run the Plugins tests
require_once MAX_PATH . '/lib/max/Plugins/tests/all_tests.php';

// Run the Delivery Engine tests
require_once MAX_PATH . '/tests/delivery/all_tests.php';

// Run the Maintenance Engine tests
require_once MAX_PATH . '/lib/max/Maintenance/tests/all_tests.php';

// Calculate and display the test run time
$testEnd = time();
$time = $testEnd - $testStart;
echo '<p>Tests took ' . $time . ' seconds</p>';

// Output the HTML footer
include_once MAX_PATH . '/tests/footer.html';

?>
