<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| Copyright (c) 2000-2003 the phpAdsNew developers                          |
| For contact details, see: http://www.phpadsnew.com/                       |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: lib-invocation.inc.php 2193 2005-03-17 16:40:35Z demian $
*/

// Required files
require_once MAX_PATH . '/lib/max/Delivery.php';
require_once MAX_PATH . '/lib/max/language/Invocation.php';
require_once MAX_PATH . '/lib/max/layerstyles/floater/invocation.inc.php';
require_once MAX_PATH . '/lib/max/other/db_proc.php';
require_once MAX_PATH . '/lib/max/Admin_DA.php';

// Register input variables
phpAds_registerGlobal (
     'block'
    ,'bannerid'
    ,'blockcampaign'
    ,'campaignid'
    ,'clientid'
    ,'codetype'
    ,'delay'
    ,'delay_type'
    ,'generate'
    ,'height'
    ,'hostlanguage'
    ,'ilayer'
    ,'layerstyle'
    ,'left'
    ,'location'
    ,'menubar'
    ,'popunder'
    ,'raw'
    ,'refresh'
    ,'resizable'
    ,'resize'
    ,'scrollbars'
    ,'source'
    ,'status'
    ,'submitbutton'
    ,'target'
    ,'template'
    ,'thirdpartytrack'
    ,'timeout'
    ,'toolbars'
    ,'top'
    ,'transparent'
    ,'uniqueid'
    ,'website'
    ,'what'
    ,'width'
    ,'withtext'
    ,'xmlrpcproto'
    ,'xmlrpctimeout'
);

// Load the required language files
Language_Invocation::load();

/*-------------------------------------------------------*/
/* Generate bannercode                                   */
/*-------------------------------------------------------*/

function phpAds_GenerateInvocationCode()
{
    $conf = $GLOBALS['_MAX']['CONF'];
    global
        $affiliateid
        ,$bannerid
        ,$block
        ,$blockcampaign
        ,$campaignid
        ,$clientid
        ,$codetype
        ,$delay
        ,$delay_type
        ,$domains_table
        ,$extra
        ,$height
        ,$hostlanguage
        ,$ilayer
        ,$left
        ,$location
        ,$menubar
        ,$popunder
        ,$raw
        ,$refresh
        ,$resizable
        ,$resize
        ,$scrollbars
        ,$source
        ,$status
        ,$target
        ,$template
        ,$thirdpartytrack
        ,$timeout
        ,$toolbars
        ,$top
        ,$transparent
        ,$uniqueid
        ,$website
        ,$what
        ,$width
        ,$withtext
        ,$zoneid
        ,$xmlrpcproto
        ,$xmlrpctimeout
    ;
    
    // Check if affiliate is on the same server
    if (isset($website) && $website != '') {
        $server_max      = parse_url('http://' . $conf['webpath']['delivery'] . '/');
        $server_affilate = parse_url($website);
        $server_same     = (@gethostbyname($server_max['host']) == @gethostbyname($server_affilate['host']));
    } else {
        $server_same = true;
    }
    
    // Clear buffer
    $buffer = '';
    
    $parameters = array();
    $uniqueid = 'a'.substr(md5(uniqid('', 1)), 0, 7);
    if (!isset($withtext)) {
        $withtext = 0;
    }
    
    // Set parameters
    if (isset($clientid) && strlen($clientid) && $clientid != '0') {
        $parameters['clientid'] = "clientid=".$clientid;
    }
    if (isset($zoneid) && $zoneid != '') {
        $parameters['zoneid'] = "zoneid=".urlencode($zoneid);
    }
    if (isset($campaignid) && strlen($campaignid) && $campaignid != '0') {
        $parameters['campaignid'] = "campaignid=".$campaignid;
    }
    if (isset($bannerid) && $bannerid != '') {
        $parameters['bannerid'] = "bannerid=".urlencode($bannerid);
    }
    if (isset($what) && $what != '') {
        $parameters['what'] = "what=".str_replace (",+", ",_", $what);
    }
    if (isset($source) && $source != '') {
        $parameters['source'] = "source=".urlencode($source);
    }

    // Remote invocation
    
    // Javascript invocation script for a publisher - all zones
    if ($codetype=='publisherJs') {
        $res = phpAds_dbQuery("
            SELECT
                mnemonic
            FROM
                {$conf['table']['prefix']}{$conf['table']['affiliates']}
            WHERE
                affiliateid=$affiliateid
        ") or phpAds_sqlDie();
        
        $mnemonic = '';
        if ($row = phpAds_dbFetchArray($res)) {
            $mnemonic = $row['mnemonic'];
        }
        
        $res = phpAds_dbQuery("
            SELECT
                affiliateid,
                zoneid,
                zonename,
                width,
                height,
                delivery
            FROM
                {$conf['table']['prefix']}{$conf['table']['zones']}
            WHERE
                affiliateid=$affiliateid
            ") or phpAds_sqlDie();


        while ($row = phpAds_dbFetchArray($res)) {
            $aZoneId[]   = $row['zoneid'];
            $aZoneName[] = $row['zonename'];
            $aZoneType[] = $row['delivery'];
            $aN[]        = $mnemonic . substr(md5(uniqid('', 1)), 0, 7);
            $aWidth[]    = $row['width'];
            $aHeight[]   = $row['height'];
        }

        if(!isset($aZoneId) || !is_array($aZoneId))
            return 'No Zones Available!';

        $script = "
<html>
<head>
<!-- NOTE: You can remove the (extensive) comments when moving this code
  --       to a live server to reduce the size of your pages
  -->

<!-- Max Media Manager Channel Script
  --
  -- Generated with Max " . MAX_VERSION_READABLE . "
  --
  -- Include this script directly ABOVE the Max Media Manager Header Script
  -- (defined below), in the <head> tag.
  --
  -- The script below should define a variable, az_channel. This variable
  -- should contain the name of the 'virtual directory' of the site.
  --
  -- For example, if you are on the football summary page of the sports section
  -- of a news site, the following should be included:
  --   var az_channel = '$mnemonic/sports/football';
  -- Conversely, if you are on the home page of the site, the variable should be:
  --   var az_channel = '$mnemonic';
  -->

<script language='JavaScript' type='text/javascript'>
<!--
  var az_channel = '$mnemonic';
//-->
</script>



<!-- Max Media Manager Header Script
  --
  -- Generated with Max " . MAX_VERSION_READABLE . "
  --
  -- Include this script below the Max Media Manager Channel Scipt (but still
  -- in the <head> tag) of every page on your site.
  --
  -- NOTE: This script does not change for any page on your site, so it may be
  --     more efficient to include it as a .js file rather than putting the
  --     entire text on every page. For example, if you cut and paste the code
  --     below and store it in a file called 'mmm.js', the code below should
  --     call the script:
  --   
  -- <script language='JavaScript' type='text/javascript' src='mmm.js'></script>
  -->

<script language='JavaScript' type='text/javascript'>
<!--
var az_p=location.protocol=='https:'?'https:':'http:';
var az_r=Math.floor(Math.random()*99999999);
if (!document.phpAds_used) document.phpAds_used = ',';
function az_adjs(z,n)
{
  if (z>-1) {
    var az=\"<\"+\"script language='JavaScript' type='text/javascript' \";
    az+=\"src='\"+az_p+\"".constructPartialDeliveryUrl($conf['file']['js'])."?n=\"+n+\"&zoneid=\"+z;
    az+=\"&source=\"+az_channel+\"&exclude=\"+document.phpAds_used+\"&r=\"+az_r;
    if (window.location) az+=\"&loc=\"+escape(window.location);
    if (document.referrer) az+=\"&referer=\"+escape(document.referrer);
    az+=\"'><\"+\"/script>\";
    document.write(az);
  }
}
function az_adpop(z,n)
{
  if (z>-1) {
    var az=\"<\"+\"script language='JavaScript' type='text/javascript' \";
    az+=\"src='\"+az_p+\"".constructPartialDeliveryUrl($conf['file']['popup'])."?n=\"+n+\"&zoneid=\"+z;
    az+=\"&source=\"+az_channel+\"&exclude=\"+document.phpAds_used+\"&r=\"+az_r;
    if (window.location) az+=\"&loc=\"+escape(window.location);
    if (document.referrer) az+=\"&referer=\"+escape(document.referrer);
    az+=\"'><\"+\"/script>\";
    document.write(az);
  }
}
//-->
</script>
</head>

<body>



<!-- Max Media Manager Ad Tag Script(s)
  --
  -- Generated with Max " . MAX_VERSION_READABLE . "
  --
  -- The following are the script(s) for each ad tag. There are a couple of items to watch out for:
  --
  -- 1. Each tag has a different zone number (var 1), and a different key value (var 2). If the
  --    key value is the same for any two zone tags, the clickthrough URL may not work correctly.
  -- 2. Each tag has a <noscript> section. If this tag is on an SSL page, change the 
  --    'http://{$conf['webpath']['delivery']}/...' to 'https://{$conf['webpath']['deliverySSL']}/...'
  --    Note that the <noscript> section cannot dynamically choose between SSL and non-SSL.
  -- 3. The <noscript> section will only show image banners. There is no width or height in
  --    these banners, so if you want these tags to allocate space for the ad before it shows,
  --    you need to add this information to the <img> tag.
  -- 4. If you do not want to deal with the intricities of the <noscript> section, delete the
  --    tag (from <noscript>... to </noscript>). On average, the <noscript> tag is called from
  --    less than 1% of internet users.
  -->
";
        
            foreach($aZoneName as $key=>$zoneName) {
                $name = str_replace('\'','',$zoneName) . " - " . str_replace('\'','',$aWidth[$key]) . "x". str_replace('\'','',$aHeight[$key]);
                if ($aZoneType[$key] != phpAds_ZonePopup) {
                    $script .= "
                   
<br /><br />$name<br />
<script language='JavaScript' type='text/javascript'>
<!--
az_adjs({$aZoneId[$key]},'{$aN[$key]}');
//-->
</script>
";
                    if ($aZoneType[$key] != phpAds_ZoneText) {
                        $script .= "<noscript>\n";
                        $script .= "  <a target='_blank' href='".constructDeliveryURL($conf['file']['click'])."?n={$aN[$key]}'>\n";
                        $script .= "  <img border='0' alt='' src='".constructDeliveryURL($conf['file']['view'])."?zoneid={$aZoneId[$key]}&n={$aN[$key]}' /></a>\n";
                        $script .= "</noscript>";
                    }
                }
                else {
                    // This is a popup zone, so generate popup.php invocation not javascript
                    $script .= "
                   
<br /><br />$name<br />
<script language='JavaScript' type='text/javascript'>
<!--
az_adpop({$aZoneId[$key]},'{$aN[$key]}');
//-->
</script>
";
                    
                }
            }
        
            $script .= "

</body>
</html>";
            
        return $script;      
    }
    
    // Remote Invocation
    if ($codetype == 'adview')  {
        $buffer  = '<!-- Max Media Manager Remote Invocation Tag' . "\n";
        $buffer .= '  --' . "\n";
        $buffer .= '  -- Generated with Max ' . MAX_VERSION_READABLE . "\n";
        $buffer .= '  --' . "\n";
        $buffer .= '  -- This tag has been generated for use on a non-SSL page. If this tag' . "\n";
        $buffer .= '  -- is to be placed on an SSL page, change the' . "\n";
        $buffer .= '  --   \'http://'.$conf['webpath']['delivery'].'/...\'' . "\n";
        $buffer .= '  -- to' . "\n";
        $buffer .= '  --   \'https://'.$conf['webpath']['deliverySSL'].'/...\'' . "\n";
        $buffer .= '  --' . "\n";
        $buffer .= '  -- This tag only shows image banners. There is no width or height in' . "\n";
        $buffer .= '  -- these banners, so if you want these tags to allocate space for the' . "\n";
        $buffer .= '  -- ad before it shows, you will need to add this information to the' . "\n";
        $buffer .= '  -- <img> tag.' . "\n";
        $buffer .= '  -->' . "\n\n";
        if (isset($uniqueid) && $uniqueid != '') {
            $parameters[] = "n=".$uniqueid;
        }
        $buffer .= "<a href='".constructDeliveryURL($conf['file']['click']);
        $buffer .= "?n=".$uniqueid;
        $buffer .= "'";
        if (isset($target) && $target != '') {
            $buffer .= " target='".$target."'";
        } else {
            $buffer .= " target='_blank'";
        }
        $buffer .= "><img src='".constructDeliveryURL($conf['file']['view']);
        if (sizeof($parameters) > 0) {
            $buffer .= "?".implode ("&", $parameters);
        }
        $buffer .= "' border='0' alt='' /></a>\n";
    }
    
    // Remote Invocation - No Cookies
    if ($codetype=='adviewnocookies') {
        $buffer  = '<!-- Max Media Manager Remote Invocation Tag - No Cookies' . "\n";
        $buffer .= '  --' . "\n";
        $buffer .= '  -- Generated with Max ' . MAX_VERSION_READABLE . "\n";
        $buffer .= '  --' . "\n";
        $buffer .= '  -- This tag has been generated for use on a non-SSL page. If this tag' . "\n";
        $buffer .= '  -- is to be placed on an SSL page, change the' . "\n";
        $buffer .= '  --   \'http://'.$conf['webpath']['delivery'].'/...\'' . "\n";
        $buffer .= '  -- to' . "\n";
        $buffer .= '  --   \'https://'.$conf['webpath']['deliverySSL'].'/...\'' . "\n";
        $buffer .= '  --' . "\n";
        $buffer .= '  -- This tag only shows image banners. There is no width or height in' . "\n";
        $buffer .= '  -- these banners, so if you want these tags to allocate space for the' . "\n";
        $buffer .= '  -- ad before it shows, you will need to add this information to the' . "\n";
        $buffer .= '  -- <img> tag.' . "\n";
        $buffer .= '  -->' . "\n\n";
        if (isset($uniqueid) && $uniqueid != '') {
            $parameters[] = "n=".$uniqueid;    
        }
        $buffer .= "<a href='".constructDeliveryURL($conf['file']['click']);
        //$buffer .= "?n=".$uniqueid;    
        $buffer .= "?bannerid=" . $bannerid;
        if ((isset($zoneid)) && ($zoneid != '')) {
            $buffer .= "&zoneid=".$zoneid;
        }
        $buffer .= "'";
        if (isset($target) && $target != '') {
            $buffer .= " target='".$target."'";
        } else {
            $buffer .= " target='_blank'";
        }
        $buffer .= "><img src='".constructDeliveryURL($conf['file']['view']);
        if (sizeof($parameters) > 0) {
            $buffer .= "?" . implode ("&", $parameters);
        }
        $buffer .= "' border='0' alt='' /></a>\n";
    }

    // Set parameters
    if (isset($target) && $target != '') {
        $parameters['target'] = "target=".urlencode($target);
    }
    
    // Remote Invocation - JavaScript
    if ($codetype == 'adjs') {
        $buffer  = '<!-- Max Media Manager Remote Invocation JavaScript Tag' . "\n";
        $buffer .= '  --' . "\n";
        $buffer .= '  -- Generated with Max ' . MAX_VERSION_READABLE . "\n";
        $buffer .= '  --' . "\n";
        // Support for 3rd party server clicktracking
        if (isset($thirdpartytrack) && $thirdpartytrack == '1') {
            $buffer .= '  -- Don\'t forget to replace the \'Insert_Clicktrack_URL_Here\' text with' . "\n";
            $buffer .= '  -- the click tracking URL if this ad is to be delivered through a 3rd' . "\n";
            $buffer .= '  -- party (non-Max) ad server.' . "\n";
            $buffer .= '  --' . "\n";
        }
        $buffer .= '  -- The <noscript> section of this tag has been generated for use on a' . "\n";
        $buffer .= '  -- non-SSL page. If this tag is to be placed on an SSL page, change the' . "\n";
        $buffer .= '  --   \'http://'.$conf['webpath']['delivery'].'/...\'' . "\n";
        $buffer .= '  -- to' . "\n";
        $buffer .= '  --   \'https://'.$conf['webpath']['deliverySSL'].'/...\'' . "\n";
        $buffer .= '  --' . "\n";
        $buffer .= '  -- This <noscript> section of this tag only shows image banners. There' . "\n";
        $buffer .= '  -- is no width or height in these banners, so if you want these tags to' . "\n";
        $buffer .= '  -- allocate space for the ad before it shows, you will need to add this' . "\n";
        $buffer .= '  -- information to the <img> tag.' . "\n";
        $buffer .= '  --' . "\n";
        $buffer .= '  -- If you do not want to deal with the intricities of the <noscript>' . "\n";
        $buffer .= '  -- section, delete the tag (from <noscript>... to </noscript>). On' . "\n";
        $buffer .= '  -- average,the <noscript> tag is called from less than 1% of internet' . "\n";
        $buffer .= '  -- users.' . "\n";
        $buffer .= '  -->' . "\n\n";
        if (isset($withtext) && $withtext != '0') {
            $parameters['withtext'] = "withtext=1";
        }
        if (isset($block) && $block == '1') {
            $parameters['block'] = "block=1";
        }
        if (isset($blockcampaign) && $blockcampaign == '1') {
            $parameters['blockcampaign'] = "blockcampaign=1";
        }
        if (isset($campaignid) && ($campaignid != '')) {
            $parameters['campaignid'] = "campaignid=".$campaignid;
        }
        $buffer .= "<script language='JavaScript' type='text/javascript'>\n";
        $buffer .= "<!--\n";
        // Support for 3rd party server clicktracking
        if (isset($thirdpartytrack) && $thirdpartytrack == '1') {
            $buffer .= "   // Insert click tracking URL here\n";
            $buffer .= "   document.phpAds_ct0 ='Insert_Clicktrack_URL_Here'\n\n";
        }
        $buffer .= "   var az_p = location.protocol=='https:'?'https:':'http:';\n";
        $buffer .= "   var az_r = Math.floor(Math.random()*99999999999);\n";
        $buffer .= "   if (!document.phpAds_used) document.phpAds_used = ',';\n";
        $buffer .= "   document.write (\"<\" + \"script language='JavaScript'\" );\n";
        $buffer .= "   document.write (\"type='text/javascript' src='\");\n";
        $buffer .= "   document.write (az_p+\"".constructPartialDeliveryUrl($conf['file']['js'])."?n=".$uniqueid."\");\n";
        if (sizeof($parameters) > 0) {
            $buffer .= "   document.write (\"&".implode ("&", $parameters)."\");\n";
        }
        $buffer .= "   document.write (\"&exclude=\" + document.phpAds_used);\n";
        $buffer .= "   document.write (\"&loc=\" + escape(window.location));\n";
        $buffer .= "   if (document.referrer)\n";
        $buffer .= "      document.write (\"&referer=\" + escape(document.referrer));\n";
        $buffer .= "   document.write ('&r=' + az_r);\n";
        $buffer .= "   document.write (\"&ct0=\" + escape(document.phpAds_ct0));\n";
        $buffer .= "   document.write (\"'><\" + \"/script>\");\n";
        $buffer .= "//-->\n";
        $buffer .= "</script>\n";
        if (isset($parameters['withtext'])) {
            unset ($parameters['withtext']);
        }
        if (isset($parameters['block'])) {
            unset ($parameters['block']);
        }
        if (isset($parameters['blockcampaign'])) {
            unset ($parameters['blockcampaign']);
        }
        if (isset($parameters['target'])) {
            unset ($parameters['target']);
        }
        if (isset($uniqueid) && $uniqueid != '') {
            $parameters['n'] = "n=".$uniqueid;    
        }
        if ($extra['delivery'] != phpAds_ZoneText) {
            $buffer .= "<noscript><a href='".constructDeliveryURL($conf['file']['click']);
            $buffer .= "?n=".$uniqueid;
            $buffer .= "'";
            if (isset($target) && $target != '') {
                $buffer .= " target='".$target."'";
            } else {
                $buffer .= " target='_blank'";
            }
            $buffer .= "><img src='".constructDeliveryURL($conf['file']['view']);
            if (sizeof($parameters) > 0) {
                $buffer .= "?".implode ("&", $parameters);
            }
            $buffer .= "' border='0' alt='' /></a></noscript>\n";
        }
    }
    
    // Remote Invocation for iframes
    if ($codetype == 'adframe') {
        $buffer  = '<!-- Max Media Manager Remote iframes Tag' . "\n";
        $buffer .= '  --' . "\n";
        $buffer .= '  -- Generated with Max ' . MAX_VERSION_READABLE . "\n";
        $buffer .= '  --' . "\n";
        // Support for 3rd party server clicktracking
        if (isset($thirdpartytrack) && $thirdpartytrack == '1') {
            $buffer .= '  -- Don\'t forget to replace the \'Insert_Clicktrack_URL_Here\' text with' . "\n";
            $buffer .= '  -- the click tracking URL if this ad is to be delivered through a 3rd' . "\n";
            $buffer .= '  -- party (non-Max) ad server.' . "\n";
            $buffer .= '  --' . "\n";
            $buffer .= '  -- Don\'t forget to replace the \'Insert_Random_Number_Here\' text with' . "\n";
            $buffer .= '  -- a cache-buster random number each time you deliver the tag through' . "\n";
            $buffer .= '  -- a 3rd party (non-Max) ad server.' . "\n";
            $buffer .= '  --' . "\n";
        }
        $buffer .= '  -- This tag has been generated for use on a non-SSL page. If this tag' . "\n";
        $buffer .= '  -- is to be placed on an SSL page, change all instances of' . "\n";
        $buffer .= '  --   \'http://'.$conf['webpath']['delivery'].'/...\'' . "\n";
        $buffer .= '  -- to' . "\n";
        $buffer .= '  --   \'https://'.$conf['webpath']['deliverySSL'].'/...\'' . "\n";
        $buffer .= '  --' . "\n";
        $buffer .= '  -- If iframes are not supported by the viewer\'s browser, then this' . "\n";
        $buffer .= '  -- tag only shows image banners. There is no width or height in these' . "\n";
        $buffer .= '  -- banners, so if you want these tags to allocate space for the ad' . "\n";
        $buffer .= '  -- before it shows, you will need to add this information to the <img>' . "\n";
        $buffer .= '  -- tag.' . "\n";
        $buffer .= '  -->' . "\n\n";
        if (isset($refresh) && $refresh != '') {
            $parameters['refresh'] = "refresh=".$refresh;
        }
        if (isset($resize) && $resize == '1') {
            $parameters['resize'] = "resize=1";
        }
        if (isset($thirdpartytrack) && $thirdpartytrack == '1') {
           $parameters['cb'] = "cb=Insert_Random_Number_Here";
           $parameters['ct0'] = "ct0=Insert_Clicktrack_URL_Here";
        }
        $buffer .= "<iframe id='".$uniqueid."' name='".$uniqueid."' src='".constructDeliveryURL($conf['file']['frame']);
        $buffer .= "?n=".$uniqueid;
        if (sizeof($parameters) > 0) {
            $buffer .= "&".implode ("&", $parameters);
        }
        $buffer .= "' framespacing='0' frameborder='no' scrolling='no'";
        if (isset($width) && $width != '' && $width != '-1') {
            $buffer .= " width='".$width."'";
        }
        if (isset($height) && $height != '' && $height != '-1') {
            $buffer .= " height='".$height."'";
        }
        if (isset($transparent) && $transparent == '1') {
            $buffer .= " allowtransparency='true'";
        }
        $buffer .= ">";
        if (isset($refresh) && $refresh != '') {
            unset ($parameters['refresh']);
        }
        if (isset($resize) && $resize == '1') {
            unset ($parameters['resize']);
        }
        if (isset($uniqueid) && $uniqueid != '') {
            $parameters['n'] = "n=".$uniqueid;    
        }
        if (isset($parameters['target'])) {
            unset ($parameters['target']);
        }
        if (isset($ilayer) && $ilayer == 1 &&  isset($width) && $width != '' && $width != '-1' && isset($height) && $height != '' && $height != '-1') {
            $buffer .= "<script language='JavaScript' type='text/javascript'>\n";
            $buffer .= "<!--\n";
            $buffer .= "   document.write (\"<nolayer>\");\n";
            $buffer .= "   document.write (\"<a href='".constructDeliveryURL($conf['file']['click']);
            $buffer .= "?n=".$uniqueid;
            $buffer .= "'";
            if (isset($target) && $target != '') {
                $buffer .= " target='".$target."'";
            } else {
                $buffer .= " target='_blank'";
            }
            $buffer .= ">\n<img src='".constructDeliveryURL($conf['file']['view']);
            if (sizeof($parameters) > 0) {
                $buffer .= "?".implode ("&", $parameters);
            }
            $buffer .= "' border='0' alt='' /></a>\");\n";
            $buffer .= "   document.write (\"</nolayer>\");\n";
            $buffer .= "   document.write (\"<ilayer id='layer".$uniqueid."' visibility='hidden' width='".$width."' height='".$height."'></ilayer>\");\n";
            $buffer .= "//-->\n";
            $buffer .= "</script>";
            $buffer .= "<noscript>\n  <a href='".constructDeliveryURL($conf['file']['click']);
            $buffer .= "?n=".$uniqueid;
            $buffer .= "'";
            if (isset($target) && $target != '') {
                $buffer .= " target='$target'";
            }
            $buffer .= ">\n  <img src='".constructDeliveryURL($conf['file']['view']);
            if (sizeof($parameters) > 0) {
                $buffer .= "?".implode ("&", $parameters);
            }
            $buffer .= "' border='0' alt='' /></a></noscript>";
        } else {
            $buffer .= "<a href='".constructDeliveryURL($conf['file']['click']);
            $buffer .= "?n=".$uniqueid;
            // Support for 3rd party server clicktracking
            if (isset($thirdpartytrack) && $thirdpartytrack == '1') {
                $buffer .= "&ct0=Insert_Clicktrack_URL_Here";
            }
            $buffer .= "'";
            if (isset($target) && $target != '') {
                $buffer .= " target='".$target."'";
            } else {
                $buffer .= " target='_blank'";
            }
            $buffer .= "><img src='".constructDeliveryURL($conf['file']['view']);
            if (sizeof($parameters) > 0) {
                $buffer .= "?";
                foreach ($parameters as $thisKey => $thisValue) {
                    if ($thisKey != "ct0") {
                        $buffer .= "&".$thisValue;
                    }
                }
            }
            $buffer .= "' border='0' alt='' /></a>";
        }
        $buffer .= "</iframe>\n";
        if (isset($parameters['n'])) {
            unset ($parameters['n']);
        }
        if (isset($target) && $target != '') {
            $parameters['target'] = "target=".urlencode($target);
        }
        if (isset($ilayer) && $ilayer == 1 && isset($width) && $width != '' && $width != '-1' && isset($height) && $height != '' && $height != '-1') {
            // Do no rewrite target frames
            $parameters['rewrite'] = 'rewrite=0';
            $buffer .= "\n\n";
            $buffer .= "<!-- Place this part of the code just above the </body> tag -->\n";
            $buffer .= "<layer src='".constructDeliveryURL($conf['file']['frame']);
            $buffer .= "?n=".$uniqueid;
            if (sizeof($parameters) > 0) {
                $buffer .= "&".implode ("&", $parameters);
            }
            $buffer .= "' width='".$width."' height='".$height."' visibility='hidden' onLoad=\"moveToAbsolute(layer".$uniqueid.".pageX,layer".$uniqueid.".pageY);clip.width=".$width.";clip.height=".$height.";visibility='show';\"></layer>";
        }
    }
    
    // Popup
    if ($codetype == 'popup') {
        $buffer  = '<!-- Max Media Manager Popup Tag' . "\n";
        $buffer .= '  --' . "\n";
        $buffer .= '  -- Generated with Max ' . MAX_VERSION_READABLE . "\n";
        $buffer .= '  --' . "\n";
        // Support for 3rd party server clicktracking
        if (isset($thirdpartytrack) && $thirdpartytrack == '1') {
            $buffer .= '  -- Don\'t forget to replace the \'Insert_Clicktrack_URL_Here\' text with' . "\n";
            $buffer .= '  -- the click tracking URL if this ad is to be delivered through a 3rd' . "\n";
            $buffer .= '  -- party (non-Max) ad server.' . "\n";
            $buffer .= '  --' . "\n";
            $buffer .= '  -- Don\'t forget to replace the \'Insert_Random_Number_Here\' text with' . "\n";
            $buffer .= '  -- a cache-buster random number each time you deliver the tag through' . "\n";
            $buffer .= '  -- a 3rd party (non-Max) ad server.' . "\n";
            $buffer .= '  --' . "\n";
        }
        $buffer .= '  -- This tag has been generated for use on a non-SSL page. If this tag' . "\n";
        $buffer .= '  -- is to be placed on an SSL page, change the' . "\n";
        $buffer .= '  --   \'http://'.$conf['webpath']['delivery'].'/...\'' . "\n";
        $buffer .= '  -- to' . "\n";
        $buffer .= '  --   \'https://'.$conf['webpath']['deliverySSL'].'/...\'' . "\n";
        $buffer .= '  -->' . "\n\n";
        if (isset($popunder) && $popunder == '1') {
            $parameters['popunder'] = "popunder=1";
        }
        if (isset($left) && $left != '' && $left != '-') {
            $parameters['left'] = "left=".$left;
        }
        if (isset($top) && $top != '' && $top != '-') {
            $parameters['top'] = "top=".$top;
        }
        if (isset($timeout) && $timeout != '' && $timeout != '-') {
            $parameters['timeout'] = "timeout=".$timeout;
        }
        if (isset($toolbars) && $toolbars == '1') {
            $parameters['toolbars'] = "toolbars=1";
        }
        if (isset($location) && $location == '1') {
            $parameters['location'] = "location=1";
        }
        if (isset($menubar) && $menubar == '1') {
            $parameters['menubar'] = "menubar=1";
        }
        if (isset($status) && $status == '1') {
            $parameters['status'] = "status=1";
        }
        if (isset($resizable) && $resizable == '1') {
            $parameters['resizable'] = "resizable=1";
        }
        if (isset($scrollbars) && $scrollbars == '1') {
            $parameters['scrollbars'] = "scrollbars=1";
        }
        if (isset($thirdpartytrack) && $thirdpartytrack == '1') {
           $parameters['cb'] = "cb=Insert_Random_Number_Here";
           $parameters['ct0'] = "ct0=Insert_Clicktrack_URL_Here";
        }
        if (isset($delay_type)) {
            if ($delay_type == 'seconds' && isset($delay) && $delay != '' && $delay != '-') {
                $parameters['delay'] = "delay=".$delay;
            } elseif ($delay_type == 'exit') {
                $parameters['delay'] = "delay=exit";
            }
        }
        $buffer .= "<script language='JavaScript' type='text/javascript' src='".constructDeliveryURL($conf['file']['popup']);
        $buffer .= "?n=".$uniqueid;
        if (sizeof($parameters) > 0) {
            $buffer .= "&".implode ("&", $parameters);
        }
        $buffer .= "'></script>\n";
    }
    
    // Remote Invocation for Layers
    if ($codetype == 'adlayer') {
        $buffer = phpAds_generateLayerCode($parameters)."\n";
    }
    
    // Remote invocation using XML-RPC
    if ($codetype == 'xmlrpc') {
        if (!isset($clientid) || $clientid == '') {
            $clientid = 0;
        }
        if (!isset($campaignid) || $campaignid == '') {
            $campaignid = 0;
        }
        if ($xmlrpcproto) {
            $params = parse_url(constructSecureDeliveryUrl($conf['file']['xmlrpc']));
        } else {
            $params = parse_url(constructDeliveryUrl($conf['file']['xmlrpc']));
        }
        if (!$xmlrpctimeout) {
            $timeout = 15;
        } else {
            $timeout = $xmlrpctimeout;
        }
        switch($hostlanguage) {
            case 'php':
                if (!isset($what) or ($what == "")) {
                    // Need to generate the waht variable here
                    if (isset($zoneid) and ($zoneid != "")) {
                        $what = "zone:" . $zoneid;
                    } elseif (isset($campaignid) and ($campaignid != "")) {
                        $what = "campaignid:" . $campaignid;
                    } elseif (isset($bannerid) and ($bannerid != "")) {
                        $what = "bannerid:" . $bannerid;
                    }
                }
                $buffer = "<"."?php\n";
                $buffer .= '    /* Max Media Manager XML-RPC Tag' . "\n";
                $buffer .= '     *' . "\n";
                $buffer .= '     * Generated with Max ' . MAX_VERSION_READABLE . "\n";
                $buffer .= '     *' . "\n";
                $buffer .= '     * As the PHP script below tries to set cookies, it must be called' . "\n";
                $buffer .= '     * before any output is sent to the user\'s browser. Once the script' . "\n";
                $buffer .= '     * has finished running, the HTML code needed to display the ad is' . "\n";
                $buffer .= '     * stored in the $adArray array (so that multiple ads can be obtained' . "\n";
                $buffer .= '     * by using mulitple tags). Once all ads have been obtained, and all' . "\n";
                $buffer .= '     * cookies set, then you can send output to the user\'s browser, and' . "\n";
                $buffer .= '     * print out the contents of $adArray where appropriate.' . "\n\n";
                $buffer .= '     * Example code for printing from $adArray is at the end of the tag - ' . "\n";
                $buffer .= '     * you will need to remove this before using the tag in production.' . "\n\n";
                $buffer .= '     * Remember to ensure that the PEAR::XML-RPC package is installed' . "\n";
                $buffer .= '     * and available to this script. You may need to alter the' . "\n";
                $buffer .= '     * \'include_path\' value immediately below.' . "\n";
                $buffer .= '     */' . "\n\n";
                $buffer .= '    ini_set(\'include_path\', \'/usr/local/lib/php\');' . "\n";
                $buffer .= '    require_once \'XML/RPC.php\';' . "\n\n";
                $buffer .= '    global $XML_RPC_Array, $XML_RPC_Boolean;' . "\n";
                $buffer .= '    global $XML_RPC_String, $XML_RPC_Struct;' . "\n\n";
                $buffer .= '    // Create an XML-RPC client to talk to the XML-RPC server' . "\n";
                $buffer .= '    $client = new XML_RPC_Client(\'' . $params[path] . '\', \'' . $params[host] . '\''; 
                if (isset($params['port'])) {
                    $buffer .= ', \'' . $params[port] . '\'';
                }
                $buffer .= ');' . "\n\n";
                $buffer .= '    // Create the XML-RPC message' . "\n";
                $buffer .= '    $message = new XML_RPC_Message(\'max.view\', array());' . "\n\n";
                $buffer .= '    // Package the cookies into an array as XML_RPC_Values' . "\n";
                $buffer .= '    $cookies = array();' . "\n";
                $buffer .= '    foreach ($_COOKIE as $key => $value) {' . "\n";
                $buffer .= '        $cookies[$key] = new XML_RPC_Value($value);' . "\n";
                $buffer .= '    }' . "\n\n";
                $buffer .= '    // Add the parameters to the message' . "\n";
                $buffer .= '    $message->addParam(new XML_RPC_Value(\'' . $what . '\', $XML_RPC_String));' . "\n";
                $buffer .= '    $message->addParam(new XML_RPC_Value(\'' . $target . '\', $XML_RPC_String));' . "\n";
                $buffer .= '    $message->addParam(new XML_RPC_Value(\'' . $source . '\', $XML_RPC_String));' . "\n";
                $buffer .= '    $message->addParam(new XML_RPC_Value(\'' . $withtext . '\', $XML_RPC_Boolean));' . "\n";
                $buffer .= '    $message->addParam(new XML_RPC_Value($_SERVER[\'REMOTE_ADDR\'], $XML_RPC_String));' . "\n";
                $buffer .= '    $message->addParam(new XML_RPC_Value($cookies, $XML_RPC_Struct));' . "\n\n";
                $buffer .= '    // Send the XML-RPC message to the server' . "\n";
                if ($xmlrpcproto) {
                    $buffer .= '    $response = $client->send($message, ' . $timeout . ', \'https\');' . "\n\n";
                } else {
                    $buffer .= '    $response = $client->send($message, ' . $timeout . ', \'http\');' . "\n\n";
                }
                $buffer .= '    // Was a response received?' . "\n";
                $buffer .= '    if (!$response) {' . "\n";
                $buffer .= '        echo \'Error: No XML-RPC response\';' . "\n";
                $buffer .= '    }' . "\n\n";
                $buffer .= '    // Was a response an error?' . "\n";
                $buffer .= '    if ($response->faultCode() != 0) {' . "\n";
                $buffer .= '        echo \'Error: \' . $response->faultString();' . "\n";
                $buffer .= '    }' . "\n\n";
                $buffer .= '    // Ensure the response is an array' . "\n";
                $buffer .= '    $value = $response->value();' . "\n";
                $buffer .= '    if ($value->kindOf() != $XML_RPC_Array) {' . "\n";
                $buffer .= '        echo \'Error: Unexpected response value\';' . "\n";
                $buffer .= '    }' . "\n\n";
                $buffer .= '    // Store any cookies sent in the response' . "\n";
                $buffer .= '    $cookies = $value->arraymem(1);' . "\n";
                $buffer .= '    if ($cookies->kindOf() == $XML_RPC_Array) {' . "\n";
                $buffer .= '        $numCookies = $cookies->arraysize();' . "\n";
                $buffer .= '        // For each cookie...' . "\n";
                $buffer .= '        for ($counter = 0; $counter < $numCookies; $counter++) {' . "\n";
                $buffer .= '            $cookie = $cookies->arraymem($counter);' . "\n";
                $buffer .= '            if (($cookie->kindOf() == $XML_RPC_Array) && ($cookie->arraysize() == 3)) {' . "\n";
                $buffer .= '                $cookieName  = $cookie->arraymem(0);' . "\n";
                $buffer .= '                $cookieValue = $cookie->arraymem(1);' . "\n";
                $buffer .= '                $cookieTime  = $cookie->arraymem(2);' . "\n";
                $buffer .= '                setcookie($cookieName->scalarval(), $cookieValue->scalarval(), $cookieTime->scalarval());' . "\n";
                $buffer .= '            }' . "\n";
                $buffer .= '        }' . "\n";
                $buffer .= '    }' . "\n\n";
                $buffer .= '    // Store the ad in the ad array' . "\n";
                $buffer .= '    $advertisement = $value->arraymem(0);' . "\n";
                $buffer .= '    if ($advertisement->kindOf() == $XML_RPC_Struct) {' . "\n";
                $buffer .= '        $htmlValue = $advertisement->structmem(\'html\');' . "\n";
                $buffer .= '        $adArray[] = $htmlValue->scalarval();' . "\n";
                $buffer .= '    }' . "\n\n";
                $buffer .= '    // Example display code - remove before use' . "\n";
                $buffer .= '    if (isset($adArray)) {' . "\n";
                $buffer .= '        foreach ($adArray as $value) {' . "\n";
                $buffer .= '            echo $value;' . "\n";
                $buffer .= '        }' . "\n";
                $buffer .= '    }' . "\n\n";
                $buffer .= "?".">\n";
                break;
        }
    }
    
    if ($codetype == 'local') {
        $path = MAX_PATH;
        $path = str_replace ('\\', '/', $path);
        $root = getenv('DOCUMENT_ROOT');
        $pos  = strpos ($path, $root);
        if (!isset($clientid)   || $clientid == '')   $clientid = 0;
        if (!isset($zoneid)     || $zoneid == '')     $zoneid = 0;
        if (!isset($campaignid) || $campaignid == '') $campaignid = 0;
        if (!isset($bannerid)   || $bannerid == '')   $bannerid = 0;
        if (is_int($pos) && $pos == 0) {
            $path = "getenv('DOCUMENT_ROOT').'".substr ($path, $pos + strlen ($root))."/{$conf['file']['local']}'";
        } else {
            $path = "'".$path."/{$conf['file']['local']}'";
        }
        $buffer .= "<"."?php\n";
        $buffer .= "  if (@include($path)) {\n";
        $buffer .= "    if (!isset($"."phpAds_context)) {\n      $"."phpAds_context = array();\n    }\n";
        if (isset($raw) && $raw == '1') {
            $buffer .= "    $"."phpAds_raw = view_local ('$what', $zoneid, $campaignid, $bannerid, '$target', '$source', '$withtext', $"."phpAds_context);\n";
            if (isset($block) && $block == '1') {
                $buffer .= "    $"."phpAds_context[] = array('!=' => 'bannerid:'.$"."phpAds_raw['bannerid']);\n";
            }
            if (isset($blockcampaign) && $blockcampaign == '1') {
                $buffer .= "    $"."phpAds_context[] = array('!=' => 'campaignid:'.$"."phpAds_raw['campaignid']);\n";
            }
            $buffer .= "  }\n    \n";
            $buffer .= "  // Assign the $"."phpAds_raw['html'] variable to your template\n";
            $buffer .= "  // echo $"."phpAds_raw['html'];\n";
        } else {
            $buffer .= "    $"."phpAds_raw = view_local('$what', $zoneid, $campaignid, $bannerid, '$target', '$source', '$withtext', $"."phpAds_context);\n";
            if (isset($block) && $block == '1') {
                $buffer .= "    $"."phpAds_context[] = array('!=' => 'bannerid:'.$"."phpAds_raw['bannerid']);\n";
            }
            if (isset($blockcampaign) && $blockcampaign == '1') {
                $buffer .= "    $"."phpAds_context[] = array('!=' => 'campaignid:'.$"."phpAds_raw['campaignid']);\n";
            }
            $buffer .= "    echo $"."phpAds_raw['html'];\n";
            $buffer .= "  }\n";
        }
        $buffer .= "?".">\n";
    }
    
    return $buffer;
}

function phpAds_generateTrackerCode($trackerId)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    global $trackerid;
    $variablesComment = '';
    $variablesQuerystring = '';
    $variables = Admin_DA::getVariables(array('tracker_id' => $trackerId), true);
    foreach ($variables as $variable) {
        $variablesComment .= "  -- Each time the page with this code on it is loaded, replace the\n";
        $variablesComment .= "  -- text INSERT_{$variable['name']}_VALUE below with the value for the\n";
        $variablesComment .= "  -- \"{$variable['description']}\" variable value, named \"{$variable['name']}\".\n";
        $variablesQuerystring .= "&{$variable['name']}=INSERT_{$variable['name']}_VALUE";
    }
    $buffer = '<!-- Max Media Manager Tracker Image Beacon Code' . "\n";
    $buffer .= '  --' . "\n";
    $buffer .= '  -- Generated with Max ' . MAX_VERSION_READABLE . "\n";
    if (isset($variablesComment) && ($variablesComment != '')) {
        $buffer .= '  --' . "\n";
        $buffer .= "$variablesComment";
    }
    $buffer .= "  --
  -- Replace INSERT_RANDOM with a random number or timestamp that is
  -- generated each time the page with this code on it is loaded, to
  -- ensure that the logging of the tracker beacon is not cached.
  --
  -- If this beacon is going on an SSL page, replace
  --  'http://{$conf['webpath']['delivery']}/...'
  -- with
  --  'https://{$conf['webpath']['deliverySSL']}/...'
  --
  -- Put this tag in the <head> portion of the web page you want to track.
  -- Any variables that will be tracked along with the beacon were
  -- configured at the time this beacon code was generated, so if you want
  -- to change the variables tracked, this code will need to be
  -- re-generated in Max Media Manager.
  -->

<img src='".constructDeliveryURL($conf['file']['conversion'])."?trackerid={$trackerId}{$variablesQuerystring}&cb=INSERT_RANDOM' width='1' height='1' border='0' />";
    return $buffer;
}

function phpAds_generateJavascriptTrackerCode($trackerId)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    $buffer  = "
<!-- Max Media Manager Tracker Javascript Beacon Code
  --
  -- Put this tag in the <head> portion of the web page you want to track,
  -- below any definitions of Javascript variables you want to track. Any
  -- Javascript variables that will be tracked need to be configured in
  -- Max Media Manager, and are defined at run-time, and so are not seen
  -- mentioned in the code below.
  -->
  
<script language='JavaScript' type='text/javascript'>
<!--
  var az_p=location.protocol=='https:'?'https:':'http:';
  var az_r=Math.floor(Math.random()*999999);
  document.write (\"<\" + \"script language='JavaScript' \");
  document.write (\"type='text/javascript' src='\"+az_p);
  document.write (\"".constructPartialDeliveryUrl($conf['file']['conversionjs'])."\");
  document.write (\"?trackerid={$trackerId}&r=\"+az_r+\"'><\" + \"/script>\");
//-->
</script>";
    return $buffer;
}

/*-------------------------------------------------------*/
/* Place invocation form                                 */
/*-------------------------------------------------------*/

function phpAds_placeInvocationForm($extra = '', $zone_invocation = false)
{
    $conf = $GLOBALS['_MAX']['CONF'];
    $pref = $GLOBALS['_MAX']['PREF'];
    global
        $block
        ,$blockcampaign
        ,$campaignid
        ,$clientid
        ,$codetype
        ,$delay
        ,$delay_type
        ,$generate
        ,$height
        ,$hostlanguage
        ,$ilayer
        ,$layerstyle
        ,$left
        ,$location
        ,$menubar
        ,$phpAds_TextDirection
        ,$popunder
        ,$raw
        ,$refresh
        ,$resizable
        ,$resize
        ,$scrollbars
        ,$source
        ,$status
        ,$submitbutton
        ,$tabindex
        ,$target
        ,$template
        ,$timeout
        ,$toolbars
        ,$top
        ,$transparent
        ,$uniqueid
        ,$what
        ,$width
        ,$withtext
        ,$bannerid
        ,$thirdpartytrack
        ,$xmlrpcproto
        ,$xmlrpctimeout
    ;
    
    // Check if affiliate is on the same server as the delivery code
    if ($extra != '' && isset ($extra['website']) && $extra['website']) {
        $server_max      = parse_url('http://' . $conf['webpath']['delivery'] . '/');
        $server_affilate = parse_url($extra['website']);
        $server_same     = (@gethostbyname($server_max['host']) == @gethostbyname($server_affilate['host']));
    } else {
        $server_same = true;
    }
    
    // Hide when integrated in zone-advanced.php
    if (!is_array($extra) || !isset($extra['zoneadvanced']) || !$extra['zoneadvanced']) {
        echo "<form name='generate' action='".$_SERVER['PHP_SELF']."' method='POST' onSubmit='return phpAds_formCheck(this);'>\n";
    }
    
    // Invocation type selection
    if (!is_array($extra) || (isset($extra['delivery']) && $extra['delivery'] != phpAds_ZoneInterstitial && $extra['delivery'] != phpAds_ZonePopup)) {
        $allowed['adlayer']         = $pref['allow_invocation_interstitial'];
        $allowed['popup']           = $pref['allow_invocation_popup'];
        $allowed['xmlrpc']          = $pref['allow_invocation_xmlrpc'];
        $allowed['adframe']         = $pref['allow_invocation_frame'];
        $allowed['adjs']            = $pref['allow_invocation_js'];
        $allowed['adview']          = $pref['allow_invocation_plain'];
        $allowed['adviewnocookies'] = $pref['allow_invocation_plain_nocookies'];
        $allowed['local']           = $pref['allow_invocation_local'];
        
        if (is_array($extra)) $allowed['popup'] = false;
        if (is_array($extra)) $allowed['adlayer'] = false;
        if (is_array($extra) && $server_same == false)  $allowed['local'] = false;
        
        if (is_array($extra) && $server_same == false && 
           ($extra['width'] == '-1' || $extra['height'] == '-1')) $allowed['adframe'] = false;
        
        if (is_array($extra) && $extra['delivery'] == phpAds_ZoneText) {
            // Only allow Javascript and Localmode
            // when using text ads
            $allowed['adlayer'] = false;
            $allowed['popup'] = false;
            $allowed['adframe'] = false;
            $allowed['adview'] = false;
            $allowed['adviewnocookies'] = false;
        }
        
        if ($zone_invocation) {
            // only for direct selection
            //$allowed['adviewnocookies'] = false;
        }
        
        if (!isset($codetype) || $allowed[$codetype] == false) {
            while (list($k,$v) = each($allowed))
                if ($v) $codetype = $k;
        }
        
        if (!isset($codetype))
            $codetype = '';
        
        
        echo "<table border='0' width='100%' cellpadding='0' cellspacing='0'>";
        echo "<tr><td height='25' colspan='3'><b>".$GLOBALS['strChooseInvocationType']."</b></td></tr>";
        echo "<tr><td height='35'>";
        echo "<select name='codetype' onChange=\"this.form.submit()\" accesskey=".$GLOBALS['keyList']." tabindex='".($tabindex++)."'>";
        
        if ($allowed['adview'])  echo "<option value='adview'".($codetype == 'adview' ? ' selected' : '').">".$GLOBALS['strInvocationRemote']."</option>";
        if ($allowed['adviewnocookies'])  echo "<option value='adviewnocookies'".($codetype == 'adviewnocookies' ? ' selected' : '').">".$GLOBALS['strInvocationRemoteNoCookies']."</option>";
        if ($allowed['adjs'])    echo "<option value='adjs'".($codetype == 'adjs' ? ' selected' : '').">".$GLOBALS['strInvocationJS']."</option>";
        if ($allowed['adframe']) echo "<option value='adframe'".($codetype == 'adframe' ? ' selected' : '').">".$GLOBALS['strInvocationIframes']."</option>";
        if ($allowed['xmlrpc'])  echo "<option value='xmlrpc'".($codetype == 'xmlrpc' ? ' selected' : '').">".$GLOBALS['strInvocationXmlRpc']."</option>";
        if ($allowed['popup'])      echo "<option value='popup'".($codetype == 'popup' ? ' selected' : '').">".$GLOBALS['strInvocationPopUp']."</option>";
        if ($allowed['adlayer']) echo "<option value='adlayer'".($codetype == 'adlayer' ? ' selected' : '').">".$GLOBALS['strInvocationAdLayer']."</option>";
        if ($allowed['local'])      echo "<option value='local'".($codetype == 'local' ? ' selected' : '').">".$GLOBALS['strInvocationLocal']."</option>";
        
        echo "</select>";
        echo "&nbsp;<input type='image' src='images/".$phpAds_TextDirection."/go_blue.gif' border='0'>";
        echo "</td></tr></table>";
        
        phpAds_ShowBreak();
        echo "<br />";
    } else {
        if ($extra['delivery'] == phpAds_ZoneInterstitial)
            $codetype = 'adlayer';
        
        if ($extra['delivery'] == phpAds_ZonePopup)
            $codetype = 'popup';
        
        if (!isset($codetype)) 
            $codetype = '';
    }
    
    if ($codetype == 'adlayer') {
        if (!isset($layerstyle)) $layerstyle = 'geocities';
        include ('../libraries/layerstyles/'.$layerstyle.'/invocation.inc.php');
    }
    
    //

    if ($codetype != '') {
        // Code
        if (isset($submitbutton) || isset($generate) && $generate) {
            echo "<table border='0' width='550' cellpadding='0' cellspacing='0'>";
            echo "<tr><td height='25'><img src='images/icon-generatecode.gif' align='absmiddle'>&nbsp;<b>".$GLOBALS['strBannercode']."</b></td>";
            
            // Show clipboard button only on IE
            if (strpos ($_SERVER['HTTP_USER_AGENT'], 'MSIE') > 0 &&
                strpos ($_SERVER['HTTP_USER_AGENT'], 'Opera') < 1) {
                echo "<td height='25' align='right'><img src='images/icon-clipboard.gif' align='absmiddle'>&nbsp;";
                echo "<a href='javascript:phpAds_CopyClipboard(\"bannercode\");'>".$GLOBALS['strCopyToClipboard']."</a></td></tr>";
            } else {
                echo "<td>&nbsp;</td>";
            }
            echo "<tr height='1'><td colspan='2' bgcolor='#888888'><img src='images/break.gif' height='1' width='100%'></td></tr>";
            echo "<tr><td colspan='2'><textarea name='bannercode' class='code-gray' rows='6' cols='55' style='width:550;' readonly>".htmlspecialchars(phpAds_GenerateInvocationCode())."</textarea></td></tr>";
            echo "</table><br />";
            phpAds_ShowBreak();
            echo "<br />";
            
            $generated = true;
        } else {
            $generated = false;
        }
        
        // Hide when integrated in zone-advanced.php
        if (!(is_array($extra) && isset($extra['zoneadvanced']) && $extra['zoneadvanced'])) {
            // Header
            // Parameters Section
            echo "<table border='0' width='100%' cellpadding='0' cellspacing='0'>";
            echo "<tr><td height='25' colspan='3'><img src='images/icon-overview.gif' align='absmiddle'>&nbsp;<b>".$GLOBALS['strParameters']."</b></td></tr>";
            echo "<tr height='1'><td width='30'><img src='images/break.gif' height='1' width='30'></td>";
            echo "<td width='200'><img src='images/break.gif' height='1' width='200'></td>";
            echo "<td width='100%'><img src='images/break.gif' height='1' width='100%'></td></tr>";
            echo "<tr".($zone_invocation || $codetype == 'adviewnocookies' ? '' : " bgcolor='#F6F6F6'")."><td height='10' colspan='3'>&nbsp;</td></tr>";
        }
        if ($codetype == 'adview') {
            $show = array ('what' => true, 'clientid' => true, 'campaignid' => true, 'target' => true, 'source' => true);
        }
        if ($codetype == 'adviewnocookies') {
            if (!$zone_invocation) {
                $show = array ('what' => true, 'clientid' => true, 'campaignid' => true, 'target' => true, 'source' => true, 'bannerid' => true);
            } else {
                $show = array ('what' => true, 'clientid' => true, 'campaignid' => true, 'target' => true, 'source' => true, 'bannerzone' => true);
            }
        }
        if ($codetype == 'adjs') {
            $show = array ('what' => true, 'clientid' => true, 'campaignid' => true, 'block' => true, 'target' => true, 'source' => true, 'withtext' => true, 'blockcampaign' => true);
        }
        if ($codetype == 'adframe') {
            $show = array ('what' => true, 'clientid' => true, 'campaignid' => true, 'target' => true, 'source' => true, 'refresh' => true, 'size' => true, 'resize' => true, 'transparent' => true, 'ilayer' => true);
        }
        if ($codetype == 'ad') {
            $show = array ('what' => true, 'clientid' => true, 'campaignid' => true, 'target' => true, 'source' => true, 'withtext' => true, 'size' => true, 'resize' => true, 'transparent' => true);
        }
        if ($codetype == 'popup') {
            $show = array ('what' => true, 'clientid' => true, 'campaignid' => true, 'target' => true, 'source' => true, 'absolute' => true, 'popunder' => true, 'timeout' => true, 'delay' => true, 'windowoptions' => true);
        }
        if ($codetype == 'adlayer') {
            $show = phpAds_getLayerShowVar();
        }
        if ($codetype == 'xmlrpc') {
            $show = array ('what' => true, 'clientid' => true, 'campaignid' => true, 'target' => true, 'source' => true, 'withtext' => true, 'template' => true, 'hostlanguage' => true, 'xmlrpcproto' => true, 'xmlrpctimeout' => true);
        }
        if ($codetype == 'local') {
            $show = array ('what' => true, 'clientid' => true, 'campaignid' => true, 'target' => true, 'source' => true, 'withtext' => true, 'block' => true, 'blockcampaign' => true, 'raw' => true);
        }
        // What
        if (!$zone_invocation && isset($show['what']) && $show['what'] == true  && $codetype != 'adviewnocookies') {
            echo "<tr bgcolor='#F6F6F6'><td width='30'>&nbsp;</td>";
            echo "<td width='200' valign='top'>".$GLOBALS['strInvocationWhat']."</td><td width='370'>";
            echo "<textarea class='flat' name='what' rows='3' cols='50' style='width:350px;' tabindex='".($tabindex++)."'>".(isset($what) ? stripslashes($what) : '')."</textarea></td></tr>";
            echo "<tr bgcolor='#F6F6F6'><td width='30'><img src='images/spacer.gif' height='1' width='100%'></td>";
            echo "<td bgcolor='#F6F6F6' colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>";
        }
        // CampaignID
        if (!$zone_invocation && isset($show['campaignid']) && $show['campaignid'] == true && $codetype != 'adviewnocookies') {
            // Display available campaigns...
            echo "<tr bgcolor='#F6F6F6'><td width='30'>&nbsp;</td>\n";
            echo "<td width='200'>".$GLOBALS['strInvocationCampaignID']."</td><td width='370'>\n";
            echo "<select name='campaignid' style='width:350px;' tabindex='".($tabindex++)."'>\n";
            echo "<option value='0'>-</option>\n";
            if (phpAds_isUser(phpAds_Admin)) {
                $query = "SELECT campaignid,campaignname".
                    " FROM ".$conf['table']['prefix'].$conf['table']['campaigns'];
            } elseif (phpAds_isUser(phpAds_Agency)) {
                $query = "SELECT m.campaignid AS campaignid".
                    ",m.campaignname AS campaignname".
                    " FROM ".$conf['table']['prefix'].$conf['table']['campaigns']." AS m".
                    ",".$conf['table']['prefix'].$conf['table']['clients']." AS c".
                    " WHERE m.clientid=c.clientid".
                    " AND c.agencyid=".phpAds_getAgencyID();
            }
            $res = phpAds_dbQuery($query)
                or phpAds_sqlDie();
            while ($row = phpAds_dbFetchArray($res)) {
                echo "<option value='".$row['campaignid']."'".($campaignid == $row['campaignid'] ? ' selected' : '').">";
                echo phpAds_buildName ($row['campaignid'], $row['campaignname']);
                echo "</option>\n";
            }
            echo "</select>\n";
            echo "</td></tr>";
            echo "<tr bgcolor='#F6F6F6'><td height='10' colspan='3'>&nbsp;</td></tr>";
            echo "<tr height='1'><td colspan='3' bgcolor='#888888'><img src='images/break.gif' height='1' width='100%'></td></tr>";
            echo "<tr><td height='10' colspan='3'>&nbsp;</td></tr>";
        }
        // BannerID
        if (isset($show['bannerid']) && $show['bannerid'] == true) {
            echo "<tr><td width='30'>&nbsp;</td>";
            echo "<td width='200'>".$GLOBALS['strInvocationBannerID']."</td><td width='370'>";
            if ($codetype == 'adviewnocookies') {
                echo "<input onBlur='phpAds_formUpdate(this);' class='flat' type='text' name='bannerid' value='".(isset($bannerid) ? $bannerid : '')."' style='width: 175px;' tabindex='".($tabindex++)."'></td></tr>";            
            } else {
                echo "<input class='flat' type='text' name='bannerid' size='' value='".(isset($bannerid) ? $bannerid : '')."' style='width:175px;' tabindex='".($tabindex++)."'></td></tr>";
            }
            echo "<tr><td width='30'><img src='images/spacer.gif' height='1' width='100%'></td>";
            echo "<td colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>";
        }
        // Target
        if (isset($show['target']) && $show['target'] == true) {
            echo "<tr><td width='30'>&nbsp;</td>";
            echo "<td width='200'>".$GLOBALS['strInvocationTarget']."</td><td width='370'>";
            echo "<input class='flat' type='text' name='target' size='' value='".(isset($target) ? $target : '')."' style='width:175px;' tabindex='".($tabindex++)."'></td></tr>";
            echo "<tr><td width='30'><img src='images/spacer.gif' height='1' width='100%'></td>";
        }
        // Source
        if (isset($show['source']) && $show['source'] == true) {
            echo "<td colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>";
            echo "<tr><td width='30'>&nbsp;</td>";
            echo "<td width='200'>".$GLOBALS['strInvocationSource']."</td><td width='370'>";
            echo "<input class='flat' type='text' name='source' size='' value='".(isset($source) ? $source : '')."' style='width:175px;' tabindex='".($tabindex++)."'></td></tr>";
            echo "<tr><td width='30'><img src='images/spacer.gif' height='1' width='100%'></td>";
        }
        // WithText
        if (isset($show['withtext']) && $show['withtext'] == true) {
            echo "<td colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>";
            echo "<tr><td width='30'>&nbsp;</td>";
            echo "<td width='200'>".$GLOBALS['strInvocationWithText']."</td>";
            echo "<td width='370'><input type='radio' name='withtext' value='1'".(isset($withtext) && $withtext != 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strYes']."<br />";
            echo "<input type='radio' name='withtext' value='0'".(!isset($withtext) || $withtext == 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strNo']."</td>";
            echo "</tr>";
            echo "<tr><td width='30'><img src='images/spacer.gif' height='1' width='100%'></td>";
        }
        // Support for 3rd Party Clicktracking
        echo "<td colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>";
        echo "<tr><td width='30'>&nbsp;</td>";
        echo "<td width='200'>".$GLOBALS['str3rdPartyTrack']."</td>";
        echo "<td width='370'><input type='radio' name='thirdpartytrack' value='1'".(!isset($thirdpartytrack) || $thirdpartytrack != 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strYes']."<br />";
        echo "<input type='radio' name='thirdpartytrack' value='0'".(isset($thirdpartytrack) && $thirdpartytrack == 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strNo']."</td>";
        echo "</tr>";
        echo "<tr><td width='30'><img src='images/spacer.gif' height='1' width='100%'></td>";
        // Refresh
        if (isset($show['refresh']) && $show['refresh'] == true) {
            echo "<td colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>";
            echo "<tr><td width='30'>&nbsp;</td>";
            echo "<td width='200'>".$GLOBALS['strIFrameRefreshAfter']."</td><td width='370'>";
            echo "<input class='flat' type='text' name='refresh' size='' value='".(isset($refresh) ? $refresh : '')."' style='width:175px;' tabindex='".($tabindex++)."'> ".$GLOBALS['strAbbrSeconds']."</td></tr>";
            echo "<tr><td width='30'><img src='images/spacer.gif' height='1' width='100%'></td>";
        }
        // Size
        if (!$zone_invocation && isset($show['size']) && $show['size'] == true) {
            echo "<td colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>";
            echo "<tr><td width='30'>&nbsp;</td>";
            echo "<td width='200'>".$GLOBALS['strFrameSize']."</td><td width='370'>";
            echo $GLOBALS['strWidth'].": <input class='flat' type='text' name='width' size='3' value='".(isset($width) ? $width : '')."' tabindex='".($tabindex++)."'>&nbsp;&nbsp;&nbsp;";
            echo $GLOBALS['strHeight'].": <input class='flat' type='text' name='height' size='3' value='".(isset($height) ? $height : '')."' tabindex='".($tabindex++)."'>";
            echo "</td></tr>";
            echo "<tr><td width='30'><img src='images/spacer.gif' height='1' width='100%'></td>";
        }
        // Resize
        if (isset($show['resize']) && $show['resize'] == true) {
            // Only show this if affiliate is on the same server
            if ($server_same) {
                echo "<td colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>";
                echo "<tr><td width='30'>&nbsp;</td>";
                echo "<td width='200'>".$GLOBALS['strIframeResizeToBanner']."</td>";
                echo "<td width='370'><input type='radio' name='resize' value='1'".(isset($resize) && $resize == 1 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strYes']."<br />";
                echo "<input type='radio' name='resize' value='0'".(!isset($resize) || $resize == 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strNo']."</td>";
                echo "</tr>";
                echo "<tr><td width='30'><img src='images/spacer.gif' height='1' width='100%'></td>";
            } else {
                echo "<input type='hidden' name='resize' value='0'>";
            }
        }
        // Transparent
        if (isset($show['transparent']) && $show['transparent'] == true) {
            echo "<td colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>";
            echo "<tr><td width='30'>&nbsp;</td>";
            echo "<td width='200'>".$GLOBALS['strIframeMakeTransparent']."</td>";
            echo "<td width='370'><input type='radio' name='transparent' value='1'".(isset($transparent) && $transparent == 1 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strYes']."<br />";
            echo "<input type='radio' name='transparent' value='0'".(!isset($transparent) || $transparent == 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strNo']."</td>";
            echo "</tr>";
            echo "<tr><td width='30'><img src='images/spacer.gif' height='1' width='100%'></td>";
        }
        // Netscape 4 ilayer
        if (isset($show['ilayer']) && $show['ilayer'] == true) {
            echo "<td colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>";
            echo "<tr><td width='30'>&nbsp;</td>";
            echo "<td width='200'>".$GLOBALS['strIframeIncludeNetscape4']."</td>";
            echo "<td width='370'><input type='radio' name='ilayer' value='1'".(isset($ilayer) && $ilayer == 1 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strYes']."<br />";
            echo "<input type='radio' name='ilayer' value='0'".(!isset($ilayer) || $ilayer == 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strNo']."</td>";
            echo "</tr>";
            echo "<tr><td width='30'><img src='images/spacer.gif' height='1' width='100%'></td>";
        }
        // Block
        if (isset($show['block']) && $show['block'] == true) {
            echo "<td colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>";
            echo "<tr><td width='30'>&nbsp;</td>";
            echo "<td width='200'>".$GLOBALS['strInvocationDontShowAgain']."</td>";
            echo "<td width='370'><input type='radio' name='block' value='1'".(isset($block) && $block != 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strYes']."<br />";
            echo "<input type='radio' name='block' value='0'".(!isset($block) || $block == 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strNo']."</td>";
            echo "</tr>";
            echo "<tr><td width='30'><img src='images/spacer.gif' height='1' width='100%'></td>";
        }
        // Blockcampaign
        if (isset($show['blockcampaign']) && $show['blockcampaign'] == true) {
            echo "<td colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>";
            echo "<tr><td width='30'>&nbsp;</td>";
            echo "<td width='200'>".$GLOBALS['strInvocationDontShowAgainCampaign']."</td>";
            echo "<td width='370'><input type='radio' name='blockcampaign' value='1'".(isset($blockcampaign) && $blockcampaign != 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strYes']."<br />";
            echo "<input type='radio' name='blockcampaign' value='0'".(!isset($blockcampaign) || $blockcampaign == 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strNo']."</td>";
            echo "</tr>";
            echo "<tr><td width='30'><img src='images/spacer.gif' height='1' width='100%'></td>";
        }
        // Raw
        if (isset($show['raw']) && $show['raw'] == true) {
            echo "<td colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>";
            echo "<tr><td width='30'>&nbsp;</td>";
            echo "<td width='200'>".$GLOBALS['strInvocationTemplate']."</td>";
            echo "<td width='370'><input type='radio' name='raw' value='1'".(isset($raw) && $raw != 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strYes']."<br />";
            echo "<input type='radio' name='raw' value='0'".(!isset($raw) || $raw == 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strNo']."</td>";
            echo "</tr>";
            echo "<tr><td width='30'><img src='images/spacer.gif' height='1' width='100%'></td>";
        }
        // AdLayer style
        if (isset($show['layerstyle']) && $show['layerstyle'] == true) {
            $layerstyles = array();
            $stylesdir = opendir('../libraries/layerstyles');
            while ($stylefile = readdir($stylesdir)) {
                if (is_dir('../libraries/layerstyles/'.$stylefile) &&
                    file_exists('../libraries/layerstyles/'.$stylefile.'/invocation.inc.php')) {
                    if (ereg('^[^.]', $stylefile)) {
                        $layerstyles[$stylefile] = isset($GLOBALS['strAdLayerStyleName'][$stylefile]) ?
                            $GLOBALS['strAdLayerStyleName'][$stylefile] :
                            str_replace("- ", "-", 
                                ucwords(str_replace("-", "- ", $stylefile)));
                    }
                }
            }
            closedir($stylesdir);
            asort($layerstyles, SORT_STRING);
            echo "<td colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>";
            echo "<tr><td width='30'>&nbsp;</td>";
            echo "<td width='200'>".$GLOBALS['strAdLayerStyle']."</td><td width='370'>";
            echo "<select name='layerstyle' onChange='this.form.submit()' style='width:175px;' tabindex='".($tabindex++)."'>";
            while (list($k, $v) = each($layerstyles)) {
                echo "<option value='$k'".($layerstyle == $k ? ' selected' : '').">$v</option>";
            }
            echo "</select>";
            echo "</td></tr>";
            echo "<tr><td width='30'><img src='images/spacer.gif' height='1' width='100%'></td>";
        }
        // Popunder
        if (isset($show['popunder']) && $show['popunder'] == true) {
            echo "<td colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>";
            echo "<tr><td width='30'>&nbsp;</td>";
            echo "<td width='200'>".$GLOBALS['strPopUpStyle']."</td>";
            echo "<td width='370'><input type='radio' name='popunder' value='0'".
                 (!isset($popunder) || $popunder != '1' ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".
                 "<img src='images/icon-popup-over.gif' align='absmiddle'>&nbsp;".$GLOBALS['strPopUpStylePopUp']."<br />";
            echo "<input type='radio' name='popunder' value='1'".
                 (isset($popunder) && $popunder == '1' ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".
                 "<img src='images/icon-popup-under.gif' align='absmiddle'>&nbsp;".$GLOBALS['strPopUpStylePopUnder']."</td>";
            echo "</tr>";
            echo "<tr><td width='30'><img src='images/spacer.gif' height='1' width='100%'></td>";
        }
        // Selay
        if (isset($show['delay']) && $show['delay'] == true) {
            echo "<td colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>";
            echo "<tr><td width='30'>&nbsp;</td>";
            echo "<td width='200'>".$GLOBALS['strPopUpCreateInstance']."</td>";
            echo "<td width='370'><input type='radio' name='delay_type' value='none'".
                 (!isset($delay_type) || ($delay_type != 'exit' && $delay_type != 'seconds') ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strPopUpImmediately']."<br />";
            echo "<input type='radio' name='delay_type' value='exit'".
                 (isset($delay_type) && $delay_type == 'exit' ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strPopUpOnClose']."<br />";
            echo "<input type='radio' name='delay_type' value='seconds'".
                 (isset($delay_type) && $delay_type == 'seconds' ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strPopUpAfterSec']."&nbsp;".
                 "<input class='flat' type='text' name='delay' size='' value='".(isset($delay) ? $delay : '-')."' style='width:50px;' tabindex='".($tabindex++)."'> ".$GLOBALS['strAbbrSeconds']."</td>";
            echo "</tr>";
            echo "<tr><td width='30'><img src='images/spacer.gif' height='1' width='100%'></td>";
        }
        // Absolute
        if (isset($show['absolute']) && $show['absolute'] == true) {
            echo "<td colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>";
            echo "<tr><td width='30'>&nbsp;</td>";
            echo "<td width='200'>".$GLOBALS['strPopUpTop']."</td><td width='370'>";
            echo "<input class='flat' type='text' name='top' size='' value='".(isset($top) ? $top : '-')."' style='width:50px;' tabindex='".($tabindex++)."'> ".$GLOBALS['strAbbrPixels']."</td></tr>";
            echo "<tr><td width='30'>&nbsp;</td>";
            echo "<td width='200'>".$GLOBALS['strPopUpLeft']."</td><td width='370'>";
            echo "<input class='flat' type='text' name='left' size='' value='".(isset($left) ? $left : '-')."' style='width:50px;' tabindex='".($tabindex++)."'> ".$GLOBALS['strAbbrPixels']."</td></tr>";
            echo "<tr><td width='30'><img src='images/spacer.gif' height='1' width='100%'></td>";
        }
        // Timeout
        if (isset($show['timeout']) && $show['timeout'] == true) {
            echo "<td colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>";
            echo "<tr><td width='30'>&nbsp;</td>";
            echo "<td width='200'>".$GLOBALS['strAutoCloseAfter']."</td><td width='370'>";
            echo "<input class='flat' type='text' name='timeout' size='' value='".(isset($timeout) ? $timeout : '-')."' style='width:50px;' tabindex='".($tabindex++)."'> ".$GLOBALS['strAbbrSeconds']."</td></tr>";
            echo "<tr><td width='30'><img src='images/spacer.gif' height='1' width='100%'></td>";
        }
        // Window options
        if (isset($show['windowoptions']) && $show['windowoptions'] == true) {
            echo "<td colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>";
            echo "<tr><td width='30'>&nbsp;</td><td width='200' valign='top'>".$GLOBALS['strWindowOptions']."</td><td width='370'>";
            echo "<table cellpadding='0' cellspacing='0' border='0'>";
            echo "<tr><td>".$GLOBALS['strShowToolbars']."</td><td>&nbsp;&nbsp;&nbsp;</td><td>";
            echo "<input type='radio' name='toolbars' value='1'".(isset($toolbars) && $toolbars != 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strYes']."<br />";
            echo "</td><td>&nbsp;&nbsp;&nbsp;</td><td>";
            echo "<input type='radio' name='toolbars' value='0'".(!isset($toolbars) || $toolbars == 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strNo']."";
            echo "</td></tr><tr><td colspan='5'><img src='images/break-l.gif' height='1' width='200' vspace='2'></td></tr>";
            echo "<tr><td>".$GLOBALS['strShowLocation']."</td><td>&nbsp;&nbsp;&nbsp;</td><td>";
            echo "<input type='radio' name='location' value='1'".(isset($location) && $location != 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strYes']."<br />";
            echo "</td><td>&nbsp;&nbsp;&nbsp;</td><td>";
            echo "<input type='radio' name='location' value='0'".(!isset($location) || $location == 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strNo']."";
            echo "</td></tr><tr><td colspan='5'><img src='images/break-l.gif' height='1' width='200' vspace='2'></td></tr>";
            echo "<tr><td>".$GLOBALS['strShowMenubar']."</td><td>&nbsp;&nbsp;&nbsp;</td><td>";
            echo "<input type='radio' name='menubar' value='1'".(isset($menubar) && $menubar != 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strYes']."<br />";
            echo "</td><td>&nbsp;&nbsp;&nbsp;</td><td>";
            echo "<input type='radio' name='menubar' value='0'".(!isset($menubar) || $menubar == 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strNo']."";
            echo "</td></tr><tr><td colspan='5'><img src='images/break-l.gif' height='1' width='200' vspace='2'></td></tr>";
            echo "<tr><td>".$GLOBALS['strShowStatus']."</td><td>&nbsp;&nbsp;&nbsp;</td><td>";
            echo "<input type='radio' name='status' value='1'".(isset($status) && $status != 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strYes']."<br />";
            echo "</td><td>&nbsp;&nbsp;&nbsp;</td><td>";
            echo "<input type='radio' name='status' value='0'".(!isset($status) || $status == 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strNo']."";
            echo "</td></tr><tr><td colspan='5'><img src='images/break-l.gif' height='1' width='200' vspace='2'></td></tr>";
            echo "<tr><td>".$GLOBALS['strWindowResizable']."</td><td>&nbsp;&nbsp;&nbsp;</td><td>";
            echo "<input type='radio' name='resizable' value='1'".(isset($resizable) && $resizable != 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strYes']."<br />";
            echo "</td><td>&nbsp;&nbsp;&nbsp;</td><td>";
            echo "<input type='radio' name='resizable' value='0'".(!isset($resizable) || $resizable == 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strNo']."";
            echo "</td></tr><tr><td colspan='5'><img src='images/break-l.gif' height='1' width='200' vspace='2'></td></tr>";
            echo "<tr><td>".$GLOBALS['strShowScrollbars']."</td><td>&nbsp;&nbsp;&nbsp;</td><td>";
            echo "<input type='radio' name='scrollbars' value='1'".(isset($scrollbars) && $scrollbars != 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strYes']."<br />";
            echo "</td><td>&nbsp;&nbsp;&nbsp;</td><td>";
            echo "<input type='radio' name='scrollbars' value='0'".(!isset($scrollbars) || $scrollbars == 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strNo']."";
            echo "</td></tr>";
            echo "</table>";
            echo "</td></tr><tr><td width='30'><img src='images/spacer.gif' height='1' width='100%'></td>";
        }
        // AdLayer custom code
        if (isset($show['layercustom']) && $show['layercustom'] == true) {
            phpAds_placeLayerSettings();
        }
        // XML-RPC Call via HTTP or HTTPS
        if (isset($show['xmlrpcproto']) && $show['xmlrpcproto'] == true) {
            echo "<td colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>";
            echo "<tr><td width='30'>&nbsp;</td>";
            echo "<td width='200'>".$GLOBALS['strXmlRpcProtocol']."</td>";
            echo "<td width='370'><input type='radio' name='xmlrpcproto' value='1'".(isset($xmlrpcproto) && $xmlrpcproto != 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strYes']."<br />";
            echo "<input type='radio' name='xmlrpcproto' value='0'".(!isset($xmlrpcproto) || $xmlrpcproto == 0 ? ' checked' : '')." tabindex='".($tabindex++)."'>&nbsp;".$GLOBALS['strNo']."</td>";
            echo "</tr>";
            echo "<tr><td width='30'><img src='images/spacer.gif' height='1' width='100%'></td>";
        }
        // XML-RPC Call Timeout
        if (isset($show['xmlrpctimeout']) && $show['xmlrpctimeout'] == true) {
            echo "<tr><td width='30'>&nbsp;</td>";
            echo "<td width='200'>".$GLOBALS['strXmlRpcTimeout']."</td><td width='370'>";
            echo "<input class='flat' type='text' name='xmlrpctimeout' size='' value='".(isset($xmlrpctimeout) ? $xmlrpctimeout : '')."' style='width:175px;' tabindex='".($tabindex++)."'></td></tr>";
            echo "<tr><td width='30'><img src='images/spacer.gif' height='1' width='100%'></td>";
        }
        // Host Language
        if (isset($show['hostlanguage']) && $show['hostlanguage'] == true) {
            echo "<td colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>";
            echo "<tr><td width='30'>&nbsp;</td>";
            echo "<td width='200'>".$GLOBALS['strXmlRpcLanguage']."</td><td width='370'>";
            echo "<select name='hostlanguage' tabindex='".($tabindex++)."'>";
            echo "<option value='php'".($hostlanguage == 'php' ? ' selected' : '').">PHP</option>";
            echo "</select>";
            echo "</td></tr>";
            echo "<tr><td width='30'><img src='images/spacer.gif' height='1' width='100%'></td>";
        }
        // Hide when integrated in zone-advanced.php
        if (!(is_array($extra) && isset($extra['zoneadvanced']) && $extra['zoneadvanced'])) {
            // Footer
            echo "<tr><td height='10' colspan='3'>&nbsp;</td></tr>";
            echo "<tr height='1'><td colspan='3' bgcolor='#888888'><img src='images/break.gif' height='1' width='100%'></td></tr>";
            echo "</table>";
            echo "<br /><br />";
            echo "<input type='hidden' value='".($generated ? 1 : 0)."' name='generate'>";
            if ($generated) {
                echo "<input type='submit' value='".$GLOBALS['strRefresh']."' name='submitbutton' tabindex='".($tabindex++)."'>";
            } else {
                echo "<input type='submit' value='".$GLOBALS['strGenerate']."' name='submitbutton' tabindex='".($tabindex++)."'>";
            }
        }
    }
    // Put extra hidden fields
    if (is_array($extra)) {
        while (list($k, $v) = each($extra)) {
            echo "<input type='hidden' value='$v' name='$k'>";
        }
    }
    // Hide when integrated in zone-advanced.php
    if (!is_array($extra) || !isset($extra['zoneadvanced']) || !$extra['zoneadvanced']) {
        echo "</form><br /><br />";
    }
    // Javascript form requirements
    if ($codetype == 'adviewnocookies') {
        echo "<script language='JavaScript'>\n";
        echo "<!--\n";
        echo "\tphpAds_formSetRequirements('bannerid', '".addslashes($GLOBALS['strInvocationBannerID'])."', true)\n";
        echo "-->\n";
        echo "</script>\n";
    }
}

?>
